/* scanner for a toy Pascal-like language */
%{
/* need this for the call to atof() below */
#include <stdio.h>
%}

LAGHUSVARA		a|i|u|\.r
DIIRGHASVARA	aa|ii|uu|\.r\.r|\.l|\.l\.l|e|ai|o|au
SVARA			{LAGHUSVARA}|{DIIRGHASVARA}
ANUSVAARA		{SVARA}\.m
VISARGA			{SVARA}\.h
KHANDAKAARA		\.a
SEPARATOR		\{\}
SPACE			[ \t]+|{KHANDAKAARA}+|{SEPARATOR}+		

HALANT			{SVARA}{VYANJANA}[ \t]+

NEWLINE			\n

ANUNAASIKA		\#

ARDHAVIRAAMA	\|
VIRAAMA			\|\|

HYPHEN 			\-

SAMKHYAA		[0-9]+

KAVARGA			k|kh|g|gh|\"n
CAVARGA			c|ch|j|jh|\~n
TTAVARGA		\.t|\.th|\.d|\.dh|\.n
TAVARGA			t|th|d|dh|n
PAVARGA			p|ph|b|bh|m
ANTAHSTHA		y|r|l|v
UUSMA			\"s|\.s|s|h

VYANJANA		{KAVARGA}|{CAVARGA}|{TTAVARGA}|{TAVARGA}|{PAVARGA}|{ANTAHSTHA}|{UUSMA}

%%

{SPACE}				{ }

{VYANJANA}			{ fprintf( yyout, "V" ); }

{ARDHAVIRAAMA}		{ }

{VIRAAMA}			{ }

{SAMKHYAA}			{ }

{HYPHEN}			{ }

{ANUNAASIKA}		{ }

{LAGHUSVARA}		{ fprintf( yyout, "L" ); }

{DIIRGHASVARA}		{ fprintf( yyout, "D" ); }

{HALANT}			{ fprintf( yyout, "D" ); }

{ANUSVAARA}			{ fprintf( yyout, "D" ); }

{VISARGA}			{ fprintf( yyout, "D" ); }

{NEWLINE}			{ fprintf( yyout, "\n" ); }

L					{ fprintf( yyout, "1" ); }

L/VV+				{ fprintf( yyout, "2" ); }

L/V{NEWLINE}		{ fprintf( yyout, "2" ); }

D					{ fprintf( yyout, "2" ); }

V					{ }

%%

main( argc, argv )
int argc;
char **argv;
{
	++argv, --argc;	/* skip over program name */

	/* first pass to get laghu, diirgha and vyanjana */
    if ( argc > 0 )
	    yyin = fopen( argv[0], "r" );
    else
	    yyin = stdin;
	yyout = fopen( ".out.tmp", "w" );
    yylex();
	fclose( yyin );
	fclose( yyout );

	/* second pass to make the pre-samyukta laghus as diirghas */
	yyin = fopen( ".out.tmp", "r" );
	yyout = stdout;
    yylex();
	fclose( yyin );
	fclose( yyout );	
	
	return 0;
}

